/*
 * Copyright (C) 2023 Cobblemon Contributors
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#!/usr/bin/env node

'use strict';

var spawnSync = require('child_process').spawnSync;
var libc = require('../');

var spawnOptions = {
  env: process.env,
  shell: true,
  stdio: 'inherit'
};

if (libc.isNonGlibcLinux) {
  spawnOptions.env.LIBC = process.env.LIBC || libc.family;
}

process.exit(spawnSync(process.argv[2], process.argv.slice(3), spawnOptions).status);
