/*
 * Copyright (C) 2023 Cobblemon Contributors
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

var through  = require('through2').obj
var tokenize = require('./index')

module.exports = createStream

function createStream(opt) {
  var generator = tokenize(opt)

  return through(write, end)

  function write(chunk, _, next) {
    flush(this, chunk)
    next()
  }

  function end() {
    flush(this, null)
    this.push(null)
  }

  function flush(stream, chunk) {
    var tokens = generator(chunk)
    for (var i = 0; i < tokens.length; i++) {
      stream.push(tokens[i])
    }
  }
}
